//---------------------------------------------------------------------------
#ifndef Demo1H
#define Demo1H
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "OpenGLPanel.h"
#include <ComCtrls.hpp>
#include <Dialogs.hpp>
#include <ExtCtrls.hpp>
#include "CSPIN.h"
#include <vector>
#include "pavet3d.h"
#include "ameraPolaire.h"
//---------------------------------------------------------------------------

typedef struct
{
        char nom[255];
        TYPE_RENDU rendu;
}ComboBoxRendu;

typedef enum
{
        M_PILE=0,
        M_FILE,
        M_AUTO
}TYPE_RESOLUTION;

typedef struct
{
        char nom[255];
        TYPE_RESOLUTION methodeResolution;
}ComboBoxResolution;

typedef enum
{
        C_POLAIRE=0,
        C_LIBRE
}TYPE_CAMERA;

typedef struct
{
        char nom[255];
        TYPE_CAMERA camera;
}ComboBoxChoixCamera;

typedef enum
{
        C_TRAPEZE=0,
        C_TRIANGLE,
        C_AUCUNE
}TYPE_COUPURE;

typedef struct
{
        char nom[255];
        TYPE_COUPURE coupure;
}ComboBoxChoixCoupure;
typedef struct
{
        TYPE_COUPURE type;
        float l;
        float alpha;
}Tcoupure;


typedef struct
{
        bool affPavetRouge;
        bool affPavetVert;
        bool affPavetBleu;
        bool transparence;
}OptionAffichage;




class TForm1 : public TForm
{
__published:	// IDE-managed Components
    TOpenGLPanel *OpenGLPanel1;
    TPanel *Panel1;
        TTrackBar *TrackBarRotO1;
        TTrackBar *TrackBarRotO2;
    TSaveDialog *SaveDialog1;
    TPrintDialog *PrintDialog1;
    TButton *Button1;
    TButton *Button2;
        TStaticText *StaticText4;
        TStaticText *StaticText5;
        TStaticText *StaticText7;
        TButton *ButtonAvance;
        TButton *ButtonRecule;
        TButton *ButtonTransUp;
        TButton *ButtonTransLeft;
        TButton *ButtonTransRight;
        TButton *ButtonTransDown;
        TEdit *PasCamera;
        TStaticText *StaticText8;
        TGroupBox *GroupBox1;
        TButton *ButtonStart;
        TButton *ButtonPause;
        TButton *ButtonStop;
        TStaticText *StaticText1;
        TEdit *nbPavet;
        TEdit *precision;
        TStaticText *StaticText2;
        TStaticText *StaticText3;
        TEdit *tpsMiseAjour;
        TGroupBox *GroupBox2;
        TComboBox *ComboBoxRenduRouge;
        TComboBox *ComboBoxResolution;
        TStaticText *StaticText9;
        TCheckBox *CheckBoxPRouge;
        TCheckBox *CheckBoxPBleu;
        TCheckBox *CheckBoxPVert;
        TCheckBox *CheckBoxTrans;
        TGroupBox *option_Affichage;
        TComboBox *ComboBoxRenduBleu;
        TComboBox *ComboBoxRenduVert;
        TButton *ButtonResetCamera;
        TComboBox *ComboBoxTypeCamera;
        TStaticText *StaticText6;
        TOpenDialog *OpenFile;
        TEdit *F_echantillons;
        TButton *echantillon;
        TGroupBox *GroupBox3;
        TButton *Save;
        TButton *OptionFichier;
        TSaveDialog *SaveDialog2;
        TEdit *nbPaveRouge;
        TEdit *nbPaveVert;
        TEdit *nbPaveBleu;
        TStaticText *StaticText10;
        TStaticText *StaticText11;
        TStaticText *StaticText12;
        TGroupBox *GroupBox4;
        TButton *loadProbleme;
        TEdit *fichierPbm;
        TGroupBox *GroupBox5;
        TComboBox *ComboBoxTypeCoupure;
        TStaticText *StaticText13;
        TStaticText *StaticText14;
        TEdit *alphaCoupe;
        TStaticText *StaticText15;
        TEdit *lCoupure;
        TButton *Button3;
    void __fastcall OpenGLPanel1Init(TObject *Sender);
    void __fastcall OpenGLPanel1Resize(TObject *Sender);
    void __fastcall OpenGLPanel1Paint(TObject *Sender);
    void __fastcall Button1Click(TObject *Sender);
    void __fastcall Button2Click(TObject *Sender);
    void __fastcall TrackBarRotO1Change(TObject *Sender);
    void __fastcall TrackBarRotO2Change(TObject *Sender);
        void __fastcall ButtonStartClick(TObject *Sender);
        void __fastcall ButtonPauseClick(TObject *Sender);
        void __fastcall nbPavetChange(TObject *Sender);
        void __fastcall RadioButtonPolaireClick(TObject *Sender);
        void __fastcall RadioButtonLibreClick(TObject *Sender);
        void __fastcall PasCameraChange(TObject *Sender);
        void __fastcall ButtonAvanceClick(TObject *Sender);
        void __fastcall ButtonReculeClick(TObject *Sender);
        void __fastcall ButtonTransLeftClick(TObject *Sender);
        void __fastcall ButtonTransRightClick(TObject *Sender);
        void __fastcall ButtonTransUpClick(TObject *Sender);
        void __fastcall ButtonTransDownClick(TObject *Sender);
        void __fastcall ButtonStopClick(TObject *Sender);
        void __fastcall ComboBoxRenduRougeChange(TObject *Sender);
        void __fastcall ComboBoxResolutionChange(TObject *Sender);
        void __fastcall CheckBoxPRougeClick(TObject *Sender);
        void __fastcall CheckBoxPBleuClick(TObject *Sender);
        void __fastcall CheckBoxPVertClick(TObject *Sender);
        void __fastcall CheckBoxTransClick(TObject *Sender);
        void __fastcall ComboBoxTypeCameraChange(TObject *Sender);
        void __fastcall ComboBoxRenduVertChange(TObject *Sender);
        void __fastcall ComboBoxRenduBleuChange(TObject *Sender);
        void __fastcall ButtonResetCameraClick(TObject *Sender);
        void __fastcall tpsMiseAjourChange(TObject *Sender);
        void __fastcall precisionChange(TObject *Sender);
        void __fastcall echantillonClick(TObject *Sender);
        void __fastcall OptionFichierClick(TObject *Sender);
        void __fastcall SaveClick(TObject *Sender);
        void __fastcall loadProblemeClick(TObject *Sender);
        void __fastcall alphaCoupeChange(TObject *Sender);
        void __fastcall lCoupureChange(TObject *Sender);

private:	// User declarations
public:		// User declarations
    __fastcall TForm1(TComponent* Owner);

    //permet de mettre  jour les composants de la fentre
    void __fastcall updateText();

    //permet d'initialiser les cameras
    void __fastcall initCamera();

    //permet d'initialiser les composants de la fentre
    void __fastcall initDialog();

    //un pointeur vers une camera libre
    Camera *cameraLibre;

    //un pointeur vers une camera polaire
    CameraPolaire *cameraPolaire;

    bool pause;

    OptionAffichage optionAffichage;

    TYPE_RENDU renduRouge;
    TYPE_RENDU renduVert;
    TYPE_RENDU renduBleu;

    TYPE_CAMERA camera;

    TYPE_RESOLUTION methodeResolution;

    Tcoupure coupure;
};

//---------------------------------------------------------------------------
extern PACKAGE TForm1 *Form1;
//---------------------------------------------------------------------------
#endif
