#include "Echantillon.h"
#include "Unit3.h"
#include "fichier.h"

Echantillons::Echantillons()
{
        sprintf(nameEchanFile,"");

        sprintf(nameSaveFile,"");

        nameEchanFileSaisi = false;

        nbEchantillons = 0;

        buffer = new char[MAX];

        ResetBruitBlanc();
}

unsigned int Echantillons::getNumVariable()
{
        if(lEchantillon.size()==0)
                return 0;
        return (lEchantillon.at(0)).ech.size();
}

void Echantillons::putNameFileEchantillon(const char*name)
{
        strcpy(nameEchanFile,name);

        if(strlen(nameEchanFile)>3)
        //on considre un fichier comme ok si son nom
        //est de longeur suprieur  3 caractres
        {
                nameEchanFileSaisi = true;
        }
}

void Echantillons::getNameFileEchantillon(char* name)
{
        strcpy(name,nameEchanFile);
}


void Echantillons::loadFile()
{
        float val1;
        float val2;
        unsigned int nbVal=0;

        nameEchanFileSaisi = false;

        Fichier fichier;
        Echantillon echantillon;

        if(!fichier.Init(nameEchanFile))
	{
		//Debug::Output("Fichier %s non trouv\n",nameEchanFile);
		return;
	}

        vector<Erreur> listeErreur;

        Erreur err;

	while(fichier.recherche("dt"))
	{
                fichier.lire(buffer,'=',MAX-1);
                err.numEchantillon = atoi(buffer);

                fichier.lire(buffer,'\n',MAX-1);
                sscanf(buffer,"%f %f",&val1,&val2);

                err.inter = interval(val1,val2);

                listeErreur.push_back(err);
	}

        /*
        if(listeErreur.size()==0)
        {
                //messsage d'erreur
                fichier.fermer();
                return;
        }
        */

        fichier.Set_sof();

        if(!fichier.recherche("DEBUT"))
	{
                //messsage d'erreur
                fichier.fermer();
                return;
	}

        if(!fichier.recherche("FIN"))
	{
                //messsage d'erreur
                fichier.fermer();
                return;
	}

        fichier.Set_sof();

        fichier.recherche("DEBUT");

        lEchantillon.clear();

        bool fin;
        do
        {
                fichier.lire(buffer,'\n',MAX-1);

                fin = strcmp(buffer,"FIN")==0;

                if(!fin)
                {
                        char *buff=buffer;
                        vector<interval> liste = getListeInter(&buffer,listeErreur);

                        buffer = buff;

                        if(liste.size()==0)
                        {
                                continue;
                        }

                        echantillon.ech.clear();

                        echantillon.ech = liste;

                        nbVal = (nbVal<liste.size())?liste.size():nbVal;

                        lEchantillon.push_back(echantillon);
                }

        }while(fin==false);

        fichier.fermer();

        show();

        nbEchantillons = lEchantillon.size();

        nameEchanFileSaisi = true;
}

void getNextToken(char** chaine,char* token)
{
        int i;
        char c;

        token[0]='\0';

        c = **chaine;
        for( ;; )
        {
                c = **chaine;

                if(c=='\0')
                        return;

                if(!( (c>='0' && c<='9') || c=='.' || c=='[' ))
                {
                        (*chaine)++;
                }
                else
                {
                        break;
                }
        }

        if((c>='0' && c<='9') || c=='.' )
        {
                i = 0;
                while(  (c>='0' && c<='9') || c=='.' )
                {
                        token[i++] = c;
                        (*chaine)++;
                        c = **chaine;
                }
                return;
        }

        if(c=='[')
        {
                token[0]=c;

                c = **chaine;
                i = 1;
                while(  c!=']' )
                {
                        if(c!='[')
                        {
                                token[i++] = c;
                        }
                        (*chaine)++;
                        c = **chaine;
                }
                return;
        }
}

vector<interval> Echantillons::getListeInter(char** chaine,vector<Erreur> listeErreur)
{
        char temp[255];
        int i,j;
        char c;
        float val1,val2;
        bool res;
        vector<interval> liste;
        interval inter;

        do
        {
                memset(temp,'\0',sizeof(temp));
                getNextToken(chaine,temp);

                if( strlen(temp)>0 )
                {
                        if(temp[0]=='[')
                        //c'est un interval
                        {
                                sscanf(temp+1,"%f %f",&val1,&val2);
                                liste.push_back( interval( val1,val2 ) );
                        }
                        else
                        {
                                res = getIntervalErreur(liste.size()+1,listeErreur,&inter);

                                if(res==true)
                                {
                                        val1 = atof(temp)+inter.GetInf();
                                        val2 = atof(temp)+inter.GetSup();
                                        liste.push_back( interval( val1,val2 ) );
                                }
                                else
                                {
                                        //erreur, on verra plus tard
                                        val1 = 0;
                                        val2 = 0;
                                }
                        }
                }

        }while( strlen(temp)>0 );

        return liste;
}

bool Echantillons::getIntervalErreur(int num,vector<Erreur> liste,interval*inter)
{
        unsigned int i;
        Erreur err;

        for(i=0;i<liste.size();i++)
        {
                err = liste.at(i);
                if(err.numEchantillon == num)
                {
                        *inter = err.inter;
                        return true;
                }
        }

        return false;
}

void Echantillons::show()
{
        if(lEchantillon.size()==0)
                return;

        Echantillon echantillon = lEchantillon.at(0);

        int nbVal = echantillon.ech.size();
        OKHelpBottomDlg->StringGrid1->ColCount = nbVal+1;
        OKHelpBottomDlg->StringGrid1->RowCount = lEchantillon.size()+1;

        unsigned int rg;
        unsigned int cl;

        for(rg=0;rg<lEchantillon.size();rg++)
        {
                sprintf(buffer,"ech. %d",rg+1);
                OKHelpBottomDlg->StringGrid1->Cells[0][rg+1] = buffer;
        }


        for(cl=0;cl<echantillon.ech.size();cl++)
        {
                sprintf(buffer,"X%d",cl+1);
                OKHelpBottomDlg->StringGrid1->Cells[cl+1][0] = buffer;
        }

        for(rg=0;rg<lEchantillon.size();rg++)
        {
                echantillon = lEchantillon.at(rg);
                for(cl=0;cl<echantillon.ech.size();cl++)
                {
                        interval inter = echantillon.ech.at(cl);
                        sprintf(buffer,"[%f %f]",inter.GetInf(),inter.GetSup());
                        OKHelpBottomDlg->StringGrid1->Cells[cl+1][rg+1] = buffer;
                }
        }

        OKHelpBottomDlg->Show();
}

void Echantillons::setNumEchantillon(unsigned int numEch)
{
        numeroEch = numEch;
}

interval Echantillons::X(unsigned int num)
{
        interval inter;
        interval inter2;

        if(numeroEch<lEchantillon.size())
        {
                Echantillon echan = lEchantillon.at(numeroEch);

                if(num-1<echan.ech.size() && num>0)
                        inter = echan.ech.at(num-1);
        }

        /*
        if(num==2)
        {
                inter2.SetInf(inter.GetInf()-bruit_blanc);
                inter2.SetSup(inter.GetSup()+bruit_blanc);
        }
        else
        {
                inter2 = inter;
        }
        */

        return inter;
}

void Echantillons::addBruitBlanc(double rayon_bruit_blanc)
{
        bruit_blanc += rayon_bruit_blanc;
}

void Echantillons::ResetBruitBlanc(void)
{
        bruit_blanc = 0.0;
}

