#ifndef Echantillons_h
#define Echantillons_h
#include "interval.h"
#include <vector>
#include <string.h>
#define MAX 512

typedef struct
{
        //vector d'interval
        /*
        expl:
           X        Y
        [12 32]  [25 30] ...       <- voila c'est a un vecteur chantillons
              ...
        [1   3]  [5   3] ...
        */
        vector<interval> ech;
}Echantillon;

typedef struct
{
        //permet d'associer un interval d'erreur
        // une variable
        interval inter;
        int numEchantillon;
}Erreur;

class Echantillons
{
private:
        char* buffer;
        //nom du ficher echantillons
        char nameEchanFile[255];

        //nom du fichier de sauvegarde
        char nameSaveFile[255];

        //permet de savoir si le fichier
        //d'chantillons a t choisi et est correct
        bool nameEchanFileSaisi;

        unsigned int numeroEch;

        //liste de donnes d'chantillons
        vector<Echantillon> lEchantillon;

        vector<interval> getListeInter(char** chaine,vector<Erreur> listeErreur);

        bool getIntervalErreur(int num,vector<Erreur> liste,interval*inter);

public:
        Echantillons();

        //permet de sauver le nom du fichier d'chantillons
        void putNameFileEchantillon(const char*name);

        //permet de recuprer le nom du fichier d'chantillons
        void getNameFileEchantillon(char* name);

        //permet de recuprer le nombre de variable
        unsigned int getNumVariable();

        //permet de charger un fichier
        void loadFile();

        interval X(unsigned int num);

        void setNumEchantillon(unsigned int numEch);

        void addBruitBlanc(double rayon_bruit_blanc);

        void ResetBruitBlanc(void);

        void show();

        //nombre d'chantillons
        unsigned int nbEchantillons;
        double bruit_blanc;

};

#endif
