#include<iostream.h>
#include "Matrice.h"

Matrice::Matrice()
{
	int i = 0;
	int j = 0;

	for(i = 0; i < 4; i++)
	{
		for(j = 0; j < 4; j++)
		{
			mat[i][j] = 0;
		}
	}
}

void Matrice::calculVecteur(double o1,double o2,double o3,
		Vecteur &u,Vecteur &v,Vecteur &w)
{
	double c1 = cos(o1);
	double s1 = sin(o1);
	double c2 = cos(o2);
	double s2 = sin(o2);
	double c3 = cos(o3);
	double s3 = sin(o3);
	
	Vecteur x(1,0,0);
	Vecteur y(0,1,0);
	Vecteur z(0,0,1);
	
	Matrice M;
	
	M = rotationX(c1, s1);
	
	Vecteur u1 = image(M, x);
	Vecteur v1 = image(M, y);
	Vecteur w1 = image(M, z);
	
	M = rotationY(c2, s2);
	
	Vecteur u2 = image(M, u1);
	Vecteur v2 = image(M, v1);
	Vecteur w2 = image(M, w1);
	
	M = rotationZ(c3, s3);
	
	Vecteur u3 = image(M, u2);
	Vecteur v3 = image(M, v2);
	Vecteur w3 = image(M, w2);
	
	int i = 0;

	for(i = 0; i < 3; i++)
	{
		if(nonNul(u3.get(i)))
			u.set(i, u3.get(i));
		else
			u.set(i, 0);
			
		if(nonNul(v3.get(i)))
			v.set(i, v3.get(i));
		else
			v.set(i, 0);
			
		if(nonNul(w3.get(i)))
			w.set(i, w3.get(i));
		else
			w.set(i, 0);
	}
}

Matrice::Matrice(double tab[16])
{
	int i = 0;
	int j = 0;

	for(i = 0; i < 4; i++)
	{
		for(j = 0; j < 4; j++)
		{
			mat[j][i] = tab[i * 4 + j];
		}
	}
}

Matrice::Matrice(Matrice const &m)
{
	int i = 0;
	int j = 0;

	for(i = 0; i < 4; i++)
	{
		for(j = 0; j < 4; j++)
		{
			mat[i][j] = m.mat[i][j];
		}
	}
}

void Matrice::set(int l, int c, double a)
{
	mat[l][c] = a;
}

double Matrice::get(int l, int c)
{
	return mat[l][c];
}

Matrice Matrice::produitMatrice(Matrice m1, Matrice m2)
{
	Matrice res;
	int i = 0;
	int j = 0;
	int k = 0;

	for(i = 0; i < 4; i++)
	{
		for(j = 0; j < 4; j++)
		{
			res.mat[i][j] = 0;
			for(k = 0; k < 4; k++)
			{
				res.mat[i][j] += (m1.mat[i][k] * m2.mat[k][j]);
			}
		}
	}
	
	return res;
}

Vecteur Matrice::image(Matrice m, Vecteur v)
{
	Vecteur res;
	int i = 0;
	int j = 0;
	double tmp = 0;
	
	for(i = 0; i < 4; i++)
	{
		tmp = 0;
		for(j = 0; j < 4; j++)
		{
			tmp += (m.mat[i][j] * v.get(j));
		}
		res.set(i, tmp);
	}
	
	return res;
}


Matrice Matrice::identite(void)
{
	Matrice res;
	int i = 0;
	int j = 0;
	
	for(i = 0; i < 4; i++)
	{
		for(j = 0; j < 4; j++)
		{
			res.mat[i][j] = 0;
		}
	}
	res.mat[0][0] = 1;
	res.mat[1][1] = 1;
	res.mat[2][2] = 1;
	res.mat[3][3] = 1;
	
	return res;
}

Matrice Matrice::rotationX(double c, double s)
{
	Matrice res;
	int i = 0;
	int j = 0;
	
	for(i = 0; i < 4; i++)
	{
		for(j = 0; j < 4; j++)
		{
			res.mat[i][j] = 0;
		}
	}
	res.mat[0][0] = 1;
	res.mat[1][1] = c;
	res.mat[1][2] = -s;
	res.mat[2][1] = s;
	res.mat[2][2] = c;
	res.mat[3][3] = 1;
	
	return res;
}

Matrice Matrice::rotationY(double c, double s)
{
	Matrice res;
	int i = 0;
	int j = 0;
	
	for(i = 0; i < 4; i++)
	{
		for(j = 0; j < 4; j++)
		{
			res.mat[i][j] = 0;
		}
	}
	res.mat[0][0] = c;
	res.mat[0][2] = s;
	res.mat[1][1] = 1;
	res.mat[2][0] = -s;
	res.mat[2][2] = c;
	res.mat[3][3] = 1;
	
	return res;
}

Matrice Matrice::rotationZ(double c, double s)
{
	Matrice res;
	int i = 0;
	int j = 0;
	
	for(i = 0; i < 4; i++)
	{
		for(j = 0; j < 4; j++)
		{
			res.mat[i][j] = 0;
		}
	}
	res.mat[0][0] = c;
	res.mat[0][1] = -s;
	res.mat[1][0] = s;
	res.mat[1][1] = c;
	res.mat[2][2] = 1;
	res.mat[3][3] = 1;
	
	return res;
}


Matrice Matrice::rotationU(double c, double s, Vecteur u)
{
	Matrice res;
	int i = 0;
	int j = 0;
	
	Vecteur v(u);
	v.normaliser();
	
	
	for(i = 0; i < 4; i++)
	{
		for(j = 0; j < 4; j++)
		{
			res.mat[i][j] = 0;
		}
	}
	res.mat[0][0] = (1-c)*v.dx*v.dx + c + 0;
	res.mat[0][1] = (1-c)*v.dx*v.dy + 0 - s * v.dz;
	res.mat[0][2] = (1-c)*v.dx*v.dz + 0 + s * v.dy;
	res.mat[1][0] = (1-c)*v.dy*v.dx + 0 + s * v.dz;
	res.mat[1][1] = (1-c)*v.dy*v.dy + c + 0;
	res.mat[1][2] = (1-c)*v.dy*v.dz + 0 - s * v.dx;
	res.mat[2][0] = (1-c)*v.dz*v.dx + 0 - s * v.dy;
	res.mat[2][1] = (1-c)*v.dz*v.dy + 0 + s * v.dx;
	res.mat[2][2] = (1-c)*v.dz*v.dz + c + 0;
	
	res.mat[3][3] = 1;
	
	return res;
}

void Matrice::affiche()
{
	int i = 0;
	int j = 0;

	for(i = 0; i < 4; i++)
	{
		for(j = 0; j < 4; j++)
		{
			cout << mat[i][j] << "\t";
		}
		cout << endl;
	}
	cout << endl;
}

void Matrice::toTab(float *tab)
{
	for(int i=0;i<4;i++)
	{
		for(int j=0;j<4;j++)
		{
			tab[j+4*i] = (float)mat[j][i];
		}
	}
}

void Matrice::toMat(float *tab)
{
	for(int i=0;i<4;i++)
	{
		for(int j=0;j<4;j++)
		{
			mat[j][i]=tab[j+4*i];
		}
	}
}

bool nonNul(double d)
{
	double epsi = double(1)/double(1000000);
	return ((d > epsi) || (d < -epsi));
}


void Matrice::calculRotation(double &o1,double &o2,double &o3,
			Vecteur u,Vecteur v)
{
	double c1,s1,c2,s2,c3,s3;
	
	Matrice::calculRotationCS(c1,s1,c2,s2,c3,s3,u,v);
	
	o1 = ((s1>=0)?1:-1)*acos(c1);
	
	o2 = ((s2>=0)?1:-1)*acos(c2);
	
	o3 = ((s3>=0)?1:-1)*acos(c3);
}

void Matrice::calculRotationCS(double & c1,double & s1,
			double & c2,double & s2,
			double & c3,double & s3,
			Vecteur u,Vecteur v)
{
	Vecteur x(1,0,0);
	Vecteur y(0,1,0);
	Vecteur z(0,0,1);
	Vecteur proj;
	
	// Troisime vecteur du tridre direct
	Vecteur w;
	Matrice M;
	w = Vecteur::prodVectoriel(u, v);

	// Rotation autour de z
	c3 = 0;
	s3 = 0;
	if(nonNul(u.get(0)) || nonNul(u.get(1)))
	{
		proj = u.projeteXY();
		c3 = Vecteur::cosinus(x, proj);
		s3 = Vecteur::sinus(x, proj, z);
	}
	else
	{
		if(nonNul(v.get(0)) || nonNul(v.get(1)))
		{
			proj = v.projeteXY();
			c3 = Vecteur::cosinus(y, proj);
			s3 = Vecteur::sinus(y, proj, z);
		}
	}
	
	M   = Matrice::rotationZ(c3, -s3);// inverse de la matrice de rotation autour de Z
	
	Vecteur u1 = Matrice::image(M, u);
	Vecteur v1 = Matrice::image(M, v);
	Vecteur w1 = Matrice::image(M, w);
	
	// Rotation autour de y
	c2 = 0;
	s2 = 0;
	if(nonNul(u1.get(0)) || nonNul(u1.get(2)))
	{
		proj = u1.projeteXZ();
		c2 = Vecteur::cosinus(x, proj);
		s2 = Vecteur::sinus(x, proj, y);
	}
	else
	{
		if(nonNul(w1.get(0)) || nonNul(w1.get(2)))
		{
			proj = w1.projeteXZ();
			c2 = Vecteur::cosinus(z, proj);
			s2 = Vecteur::sinus(z, proj, y);
		}
	}
	
	
	M   = Matrice::rotationY(c2, -s2);// inverse de la matrice de rotation autour de Y

	
	Vecteur u2 = Matrice::image(M, u1);
	Vecteur v2 = Matrice::image(M, v1);
	Vecteur w2 = Matrice::image(M, w1);

	
	// Rotation autour de x
	c1 = 0;
	s1 = 0;
	if(nonNul(v2.get(1)) || nonNul(v2.get(2)))
	{
		proj = v2.projeteYZ();
		c1 = Vecteur::cosinus(y, proj);
		s1 = Vecteur::sinus(y, proj, x);
	}
	else
	{
		if(nonNul(w2.get(1)) || nonNul(w2.get(2)))
		{
			proj = w2.projeteYZ();
			c1 = Vecteur::cosinus(z, proj);
			s1 = Vecteur::sinus(z, proj, x);
		}
	}
}

/* Inversion matricielle par la mthode de Jordan avec recherche de pivot maximum (fonction sl_inv_jordan). 

    Les paramtres d'appel de cette fonction sont : 

       a : un tableau carr (la matrice  inverser) ; 
       b : un tableau carr (la matrice inverse calcule) ; 
       n : l'ordre de la matrice. 

Elle renvoie la valeur 1 si la matrice est numriquement inversible et la valeur 0 sinon ; quand la valeur renvoye est 1, l'inverse de la matrice se trouve dans le tableau b. 

La constante entire NMAX est gale  la dimension maximale de la matrice (+1) ; la constante entire N2MAX est gale  2*NMAX-1. 
*/
int Invers(double *a,double *b,int n)
{
 	int i,j,k,l,err;
 	double max,pivot,coef;
 	double t[NMAX][N2MAX];
 	for(i=1;i<=n;i++)
 		for(j=1;j<=n;j++)
 		{
  			t[i][j]=a[(i-1)*n+(j-1)];
  			if (i==j) 
				t[i][j+n]=1.0;
			else 
				t[i][j+n]=0.0;
 		}
	err=1;
	k=1;
 	while (err==1 && k<=n)
 	{
 	 	max=fabs(t[k][k]);
 	 	l=k;
  		for(i=k+1;i<=n;i++)
  			if(max<fabs(t[i][k]))
  			{
   				max=fabs(t[i][k]);
   				l=i;
  			}
  		
		if(max!=0)
  		{
   			for(j=k;j<=2*n;j++)
   			{
    				max=t[k][j];
    				t[k][j]=t[l][j];
    				t[l][j]=max;
   			}
   			pivot=t[k][k];
   			for(j=k+1;j<=2*n;j++)
   				t[k][j] /= pivot;
   			for(i=1;i<=n;i++)
   				if(i!=k)
   				{
    					coef=t[i][k];
    					for(j=k+1;j<=2*n;j++)
    						t[i][j] -= coef*t[k][j];
   				}
  		}
  		else err=0;
  		k++;
 	}
 	for(i=1;i<=n;i++)
 		for(j=1;j<=n;j++)
 			b[(i-1)*n+(j-1)]=t[i][j+n];
 	return(err);
}

Matrice Matrice::inverse()
{
	Matrice m;
	
	m=*this;

	Invers(&(this->mat[0][0]),&(m.mat[0][0]),4);
	
	return m;
}


Matrice Matrice::calculMatriceHomogeneInverse(Point3d pos, Vecteur u, Vecteur v)
// u correspond a l'axe x
// v correspond a l'axe y
{
	Matrice res;
	
	res = 	calculMatriceHomogene(pos, u, v);
	
	return res.inverse();
}

Matrice Matrice::calculMatriceHomogene(Point3d pos, Vecteur u, Vecteur v)
// u correspond a l'axe x
// v correspond a l'axe y
{
	Matrice res;
	
	Vecteur w;
	w = Vecteur::prodVectoriel(u, v);
	
	for(int i = 0; i < 3; i++)
	{
		res.set(i, 0, u.get(i));
		res.set(i, 1, v.get(i));
		res.set(i, 2, w.get(i));
	}
	res.set(3, 3, 1);	
	
	// TRANSLATION
	
	
	res.set(0, 3, pos.x);
	res.set(1, 3, pos.y);
	res.set(2, 3, pos.z);
	
	return res;
}
