// ParserIntervalles.cpp: implementation of the ParserIntervalles class.
//
//////////////////////////////////////////////////////////////////////

#include "ParserIntervalles.h"



struct functionToken tabFonctions[] = 
	{
		"Fact",tFact,
		"Perm",tPerm,
		"Comb",tComb,
		"Abs",tAbs,
		"Cos",tCos,
		"Cotan",tCotan,
		"Exp",tExp,
		"Log",tLog,
		"Max",tMax,
		"Min",tMin,
		"Power",tPower,
		"Sin",tSin,
		"Sqr",tSqr,
		"Sqrt",tSqrt,
		"Tan",tTan,
		"I",tInter,
		"In",tIn,	/* In(x,y):*/
		"Inter",tInters,/* Inter(x,y):*/
		"Not",tNot,	/* not(x):*/
		"Union",tUnion, /* Union(x,y)*/
		"Disjoint",tDisjoint,/* Disjoint(x,y)*/
		"Egale",tEgale,	/* Egale(x,y)*/
		"And",tEt,	/* x et y*/
		"Or",tOu,	/* x ou y*/
		0,tEof
	};



char parseTbl[tMaxOp][tMaxOp] =
		{
		/* stk ------------------ input ------------------------ */
		/*        +   -   *   /   ^   M   f   p   c  ABS COS CTA EXP LOG MAX MIN POW SIN SQR SQT TAN Inter IN	Inters	Not	Union	Disjoint	Egale	Et	Ou	,   (   )   $  */
		/* + */ { R,  R,  S,  S,  S,  S,  S,  S,  S,  S,  S,  S,  S,  S,  S,  S,  S,  S,  S,  S,  S,  S,    E5,	E5,		E5,	E5,		E5,			E5,		E5,	E5,	R,  S,  R,  R },
		/* - */ { R,  R,  S,  S,  S,  S,  S,  S,  S,  S,  S,  S,  S,  S,  S,  S,  S,  S,  S,  S,  S,  S,    E5,	E5,		E5,	E5,		E5,			E5,		E5,	E5,	R,  S,  R,  R },
		/* * */ { R,  R,  R,  R,  S,  S,  S,  S,  S,  S,  S,  S,  S,  S,  S,  S,  S,  S,  S,  S,  S,  S,    E5,	E5,		E5,	E5,		E5,			E5,		E5,	E5,	R,  S,  R,  R },
		/* / */ { R,  R,  R,  R,  S,  S,  S,  S,  S,  S,  S,  S,  S,  S,  S,  S,  S,  S,  S,  S,  S,  S,    E5,	E5,		E5,	E5,		E5,			E5,		E5,	E5,	R,  S,  R,  R },
		/* ^ */ { R,  R,  R,  R,  S,  S,  S,  S,  S,  S,  S,  S,  S,  S,  S,  S,  S,  S,  S,  S,  S,  S,    E5,	E5,		E5,	E5,		E5,			E5,		E5,	E5,	R,  S,  R,  R },
		/* M */ { R,  R,  R,  R,  R,  S,  S,  S,  S,  S,  S,  S,  S,  S,  S,  S,  S,  S,  S,  S,  S,  S,    E5,	E5,		E5,	E5,		E5,			E5,		E5,	E5,	R,  S,  R,  R },
		/* f */ { R,  R,  R,  R,  E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4,   E4,	E4,		E4,	E4,		E4,			E4,		E4,	E4,	R,  S,  R,  R },
		/* p */ { R,  R,  R,  R,  E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4,   E4,	E4,		E4,	E4,		E4,			E4,		E4,	E4,	R,  S,  R,  R },
		/* c */ { R,  R,  R,  R,  E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4,   E4,	E4,		E4,	E4,		E4,			E4,		E4,	E4,	R,  S,  R,  R },
		/*ABS*/ { R,  R,  R,  R,  E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4,   E4,	E4,		E4,	E4,		E4,			E4,		E4,	E4,	R,  S,  R,  R },
		/*COS*/ { R,  R,  R,  R,  E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4,   E4,	E4,		E4,	E4,		E4,			E4,		E4,	E4,	R,  S,  R,  R },
		/*CTA*/ { R,  R,  R,  R,  E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4,   E4,	E4,		E4,	E4,		E4,			E4,		E4,	E4,	R,  S,  R,  R },
		/*EXP*/ { R,  R,  R,  R,  E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4,   E4,	E4,		E4,	E4,		E4,			E4,		E4,	E4,	R,  S,  R,  R },
		/*LOG*/ { R,  R,  R,  R,  E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4,   E4,	E4,		E4,	E4,		E4,			E4,		E4,	E4,	R,  S,  R,  R },
		/*MAX*/ { R,  R,  R,  R,  E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4,   E4,	E4,		E4,	E4,		E4,			E4,		E4,	E4,	R,  S,  R,  R },
		/*MIN*/ { R,  R,  R,  R,  E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4,   E4,	E4,		E4,	E4,		E4,			E4,		E4,	E4,	R,  S,  R,  R },
		/*POW*/ { R,  R,  R,  R,  E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4,   E4,	E4,		E4,	E4,		E4,			E4,		E4,	E4,	R,  S,  R,  R },
		/*SIN*/ { R,  R,  R,  R,  E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4,   E4,	E4,		E4,	E4,		E4,			E4,		E4,	E4,	R,  S,  R,  R },
		/*SQR*/ { R,  R,  R,  R,  E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4,   E4,	E4,		E4,	E4,		E4,			E4,		E4,	E4,	R,  S,  R,  R },
		/*SQT*/ { R,  R,  R,  R,  E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4,   E4,	E4,		E4,	E4,		E4,			E4,		E4,	E4,	R,  S,  R,  R },
		/*TAN*/ { R,  R,  R,  R,  E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4,   E4,	E4,		E4,	E4,		E4,			E4,		E4,	E4,	R,  S,  R,  R },
	 /*tInter*/ { R,  R,  R,  R,  E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4,   E4,	E4,		E4,	E4,		E4,			E4,		E4,	E4,	R,  S,  R,  R },
	    /*tIn*/ { E5, E5, E5, E5, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4,   E4,	E4,		E4,	E4,		E4,			E4,		R,	R,	R,  S,  R,  R },
	/*tInters*/ { R,  R,  R,  R,  E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4,   E4,	E4,		E4,	E4,		E4,			E4,		E4,	E4,	R,  S,  R,  R },
	   /*tNot*/ { E5, E5, E5, E5, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4,   E4,	E4,		E4,	E4,		E4,			E4,		R,	R,	R,  S,  R,  R },
	 /*tUnion*/ { R,  R,  R,  R,  E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4,   E4,	E4,		E4,	E4,		E4,			E4,		E4,	E4,	R,  S,  R,  R },
  /*tDisjoint*/ { R,  R,  R,  R,  E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4,   E4,	E4,		E4,	E4,		E4,			E4,		R,	R,	R,  S,  R,  R },
	 /*tEgale*/ { E5, E5, E5, E5, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4,   S,	E4,		S,	E4,		S,			S,		R,	R,	R,  S,  R,  R },
	    /*tEt*/ { E5, E5, E5, E5, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4,   S,	E4,		S,	E4,		S,			S,		R,	R,	E4, S,  R,  R },
	    /*tOu*/ { E5, E5, E5, E5, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4, E4,   S,	E4,		S,	E4,		S,			S,		S,	R,	R,  S,  R,  R },
		/* , */ { R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,  R,    E4,	R,		E4,	R,		E4,			E4,		E4,	E4,	R,  R,  R,  E4},
		/* ( */ { S,  S,  S,  S,  S,  S,  S,  S,  S,  S,  S,  S,  S,  S,  S,  S,  S,  S,  S,  S,  S,  S,    S,	S,		S,	S,		S,			S,		S,	S,	S,  S,  S,  E1},
		/* ) */ { R,  R,  R,  R,  R,  R,  E3, E3, E3, E3, E3, E3, E3, E3, E3, E3, E3, E3, E3, E3, E3, E3,   E3,	E3,		E3,	E3,		E3,			E3,		R,	R,	R,  E2, R,  R },
		/* $ */ { S,  S,  S,  S,  S,  S,  S,  S,  S,  S,  S,  S,  S,  S,  S,  S,  S,  S,  S,  S,  S,  S,	S,	S,		S,	S,		S,			S,		S,	S,	S,  S,  E3, A }
		};

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

ParserIntervalles::ParserIntervalles()
{
	Init();
}

ParserIntervalles::~ParserIntervalles()
{

}



void ParserIntervalles::insertSpace(char * str)
{
		char strBis[255];
	char token[255];

	unsigned int i,j;

	memset(strBis,'\0',255);

	i=0;

	for(;i<strlen(str)+1;)
	{
		j = getNextToken(&(str[i]),token);

		if(j==0)
		{
			char tmp[255];

            tmp[0] = str[i];
            tmp[1] = '\0';
			strcat(strBis,tmp);
			j = 1;
		}
		else
		{
			strcat(strBis,token);
		}

		strcat(strBis," ");

		i += j;
	}

	memcpy(str,strBis,strlen(strBis)+1);

}


int ParserIntervalles::error(char *msg)
{
	printf("error: %s\n", msg);
	return 1;
}


int ParserIntervalles::gettok(void)
{
	static tokEnum prevtok;
	char *s;
	/* scan for next symbol */
	if (firsttok)
	{
		firsttok = false;
		prevtok = tEof;
		
		insertSpace(chaine);

		printf("\n%s\n",chaine);

		if (*chaine == 'q')
		{
			retour = false;
			return 1;
		}
		s = strtok(chaine, " ");
	}
	else
	{
		s = strtok(NULL, " ");
	}
	/* convert symbol to token */
	if (s)
	{
		if(strcmp(s,"+")==0)
			tok = tAdd;
		else
		if(strcmp(s,"-")==0)
			tok = tSub;
		else
		if(strcmp(s,"*")==0)
			tok = tMul;
		else
		if(strcmp(s,"/")==0)
			tok = tDiv;
		else
		if(strcmp(s,"^")==0)
			tok = tPow;
		else
		if(strcmp(s,"(")==0)
			tok = tLpr;
		else
		if(strcmp(s,")")==0)
			tok = tRpr;
		else
		if(strcmp(s,",")==0)
			tok = tComa;
		else
		if(strcmp(s,"+")==0)
			tok = tAdd;
		else
		for(int i=0;;i++)
		{
			functionToken* funToken = getNameFunction(i);
			Type val;

			if(funToken==NULL)
			{
				if(isVariable(s))
				{
					if(getValeur(s,val))
					{
						tokval = val;
						tok = tVal;
						break;
					}
					else
					//variable inconnu
					{
						printf("variable %s inconnu\n",s);
						retour = false;
						return 1;
					}
				}
				else
				{
					tokval = Type(interval(atof(s)));
					tok = tVal;
					break;
				}
			}

			if(strcmp(s,funToken->fname)==0)
			{
				tok = funToken->tok;
				break;
			}
		}
	}
	else
	{
		tok = tEof;
	}
	/* check for unary minus */
	if (tok == tSub)
	{
		if (prevtok != tVal && prevtok != tRpr)
		{
			tok = tUmi;
		}
	}
	prevtok = tok;
	return 0;
}

int ParserIntervalles::shift(void)
{
	if (tok == tVal)
	{
		if (++valTop >= MAX_VAL)
			return error("val stack exhausted");
		val[valTop] = tokval;
	}
	else
	{
		if (++oprTop >= MAX_OPR)
			return	error("opr stack exhausted");
		opr[oprTop] = (char)tok;
	}
	if (gettok())
		return 1;
	return 0;
}



int ParserIntervalles::reduce(void)
{
	Type opG;
	Type opD;
	switch(opr[oprTop])
	{
		case tAdd:
			/* apply E := E + E */
			if (valTop < 1)
				return error("syntax error");

			opG = val[valTop-1];
			opD = val[valTop];

			if(opG.isBoolean() || opD.isBoolean())
			{
				return error("operand left or right mustn't be bool");
			}

			val[valTop-1] = Type(opG.getInterval()+opD.getInterval());
			valTop--;
		break;
		case tSub:
			/* apply E := E - E */
			if (valTop < 1)
				return error("syntax error");
			
			opG = val[valTop-1];
			opD = val[valTop];

			if(opG.isBoolean() || opD.isBoolean())
			{
				return error("operand left or right mustn't be bool");
			}

			val[valTop-1] = Type(opG.getInterval()-opD.getInterval());

			valTop--;
		break;
		case tMul:
			/* apply E := E * E */
			if (valTop < 1) 
				return error("syntax error");
			opG = val[valTop-1];
			opD = val[valTop];

			if(opG.isBoolean() || opD.isBoolean())
			{
				return error("operand left or right mustn't be bool");
			}

			val[valTop-1] = Type(opG.getInterval()*opD.getInterval());
			valTop--;
		break;
		case tDiv:
			/* apply E := E / E */
			if (valTop < 1) 
				return error("syntax error");
			opG = val[valTop-1];
			opD = val[valTop];

			if(opG.isBoolean() || opD.isBoolean())
			{
				return error("operand left or right mustn't be bool");
			}

			val[valTop-1] = Type(opG.getInterval()/opD.getInterval());
			valTop--;
		break;
		case tUmi:
			/* apply E := -E */
			if (valTop < 0) 
				return error("syntax error");

			opD = val[valTop];

			if(opD.isBoolean())
			{
				return error("operand right must not be bool");
			}

			val[valTop] = Type(-opD.getInterval());
		break;
		case tPow:
			/* apply E := E ^ E */
			if (valTop < 1) 
				return error("syntax error");
			
			opG = val[valTop-1];
			opD = val[valTop];

			if(opG.isBoolean() || opD.isBoolean())
			{
				return error("operand left or right mustn't be bool");
			}

			val[valTop-1] = Type( Power(opG.getInterval(),opD.getInterval()) );
			
			valTop--;
		break;
		case tFact:
			/* apply E := f(E) */
			if (valTop < 0) 
				return error("syntax error");
			
			opD = val[valTop];

			if(opD.isBoolean())
			{
				return error("operand right mustn't be bool");
			}

			val[valTop] = Type(fact(opD.getInterval()));
		break;

		case tPerm:
			/* apply E := p(N,R) */
			if (valTop < 1) 
				return error("syntax error");
			/*
			val[valTop-1] = fact(val[valTop-1])/
			fact(val[valTop-1]-val[valTop]);
			*/
			valTop--;
		break;
		case tComb:
			/* apply E := c(N,R) */
			if (valTop < 1) 
				return error("syntax error");
			
			/*
			val[valTop-1] = fact(val[valTop-1])/
			(fact(val[valTop]) *
			fact(val[valTop-1]-val[valTop]));
			*/
			valTop--;
		break;

		case tAbs:
			/* apply E := Abs(x) */
			if (valTop < 0) 
				return error("syntax error");
			
			opD = val[valTop];

			if(opD.isBoolean())
			{
				return error("operand right mustn't be bool");
			}

			val[valTop] = Type(Abs(opD.getInterval()));
		break;

		case tCos:
			/* apply E := Cos(x) */
			if (valTop < 0) 
				return error("syntax error");

			opD = val[valTop];

			if(opD.isBoolean())
			{
				return error("operand right mustn't be bool");
			}

			val[valTop] = Type(Cos(opD.getInterval()));
		break;

		case tCotan:
			/* apply E := Cotan(x) */
			if (valTop < 0) 
				return error("syntax error");
			
			opD = val[valTop];

			if(opD.isBoolean())
			{
				return error("operand right mustn't be bool");
			}

			val[valTop] = Type(Cotan(opD.getInterval()));
		break;

		case tExp:
			/* apply E := Exp(x) */
			if (valTop < 0) 
				return error("syntax error");
			
			opD = val[valTop];

			if(opD.isBoolean())
			{
				return error("operand right mustn't be bool");
			}

			val[valTop] = Type(Exp(opD.getInterval()));
		break;

		case tLog:
			/* apply E := Log(x) */
			if (valTop < 0) 
				return error("syntax error");
			opD = val[valTop];

			if(opD.isBoolean())
			{
				return error("operand right mustn't be bool");
			}

			val[valTop] = Type(Log(opD.getInterval()));
		break;

		case tMax:
			/* apply E := Max(x,y) */
			if (valTop < 1) 
				return error("syntax error");

			opG = val[valTop-1];
			opD = val[valTop];

			if(opG.isBoolean() || opD.isBoolean())
			{
				return error("operand left or right mustn't be bool");
			}

			val[valTop-1] = Type( Max(opG.getInterval(),opD.getInterval()) );
			valTop--;
		break;

		case tMin:
			/* apply E := Min(x,y) */
			if (valTop < 1) 
				return error("syntax error");

			opG = val[valTop-1];
			opD = val[valTop];

			if(opG.isBoolean() || opD.isBoolean())
			{
				return error("operand left or right mustn't be bool");
			}

			val[valTop-1] = Type( Min(opG.getInterval(),opD.getInterval()) );
			valTop--;
		break;

		case tInter:
			/* apply E := Interval(x,y) */
			if (valTop < 1) 
				return error("syntax error");

			opG = val[valTop-1];
			opD = val[valTop];

			if(opG.isBoolean() || opD.isBoolean())
			{
				return error("operand left or right mustn't be bool");
			}

			val[valTop-1] = Type( interval( (opG.getInterval()).GetInf(),(opD.getInterval()).GetInf() ) );

			valTop--;
		break;

		case tPower:
			/* apply E := Power(x,n) */
			if (valTop < 1) 
				return error("syntax error");

			opG = val[valTop-1];
			opD = val[valTop];

			if(opG.isBoolean() || opD.isBoolean())
			{
				return error("operand left or right mustn't be bool");
			}

			val[valTop-1] = Type( Power(opG.getInterval(),opD.getInterval()) );
			valTop--;
		break;

		case tSin:
			/* apply E := Sin(x) */
			if (valTop < 0) 
				return error("syntax error");
			
			opD = val[valTop];

			if(opD.isBoolean())
			{
				return error("operand right mustn't be bool");
			}

			val[valTop] = Sin(Abs(opD.getInterval()));
		break;

		case tSqrt:
			/* apply E := Sqrt(x) */
			if (valTop < 0) 
				return error("syntax error");
			
			opD = val[valTop];

			if(opD.isBoolean())
			{
				return error("operand right mustn't be bool");
			}

			val[valTop] = Sqrt(Abs(opD.getInterval()));
		break;

		case tSqr:
			/* apply E := Sqr(x) */
			if (valTop < 0) 
				return error("syntax error");
			
			opD = val[valTop];

			if(opD.isBoolean())
			{
				return error("operand right mustn't be bool");
			}

			val[valTop] = Type(Sqr(opD.getInterval()));
		break;
		
		case tTan:
			/* apply E := Tan(x) */
			if (valTop < 0) 
				return error("syntax error");
			
			opD = val[valTop];

			if(opD.isBoolean())
			{
				return error("operand right mustn't be bool");
			}

			val[valTop] = Type(Tan(opD.getInterval()));
		break;


		case tNot:
			/* apply E := Not(x) */
			if (valTop < 0) 
				return error("syntax error");
			
			opD = val[valTop];

			if(opD.isInterval())
			{
				return error("operand right mustn't be interval");
			}

			val[valTop] = Type(Non(opD.getBoolean()));
		break;

		case tIn:
			/* apply E := In(x,y) */
			if (valTop < 1) 
				return error("syntax error");

			opG = val[valTop-1];
			opD = val[valTop];

			if(opG.isBoolean() || opD.isBoolean())
			{
				return error("operand left or right mustn't be boolean");
			}

			val[valTop-1] = Type( In(opG.getInterval(),opD.getInterval()) );

			valTop--;
		break;

		case tInters:
			/* apply E := Inters(x,y) */
			if (valTop < 1) 
				return error("syntax error");

			opG = val[valTop-1];
			opD = val[valTop];

			if(opG.isBoolean() || opD.isBoolean())
			{
				return error("operand left or right mustn't be boolean");
			}

			val[valTop-1] = Type( Inter(opG.getInterval(),opD.getInterval()) );

			valTop--;
		break;

		case tUnion:
			/* apply E := Union(x,y) */
			if (valTop < 1) 
				return error("syntax error");

			opG = val[valTop-1];
			opD = val[valTop];

			if(opG.isBoolean() || opD.isBoolean())
			{
				return error("operand left or right mustn't be boolean");
			}

			val[valTop-1] = Type( Union(opG.getInterval(),opD.getInterval()) );

			valTop--;
		break;


		case tDisjoint:
			/* apply E := Disjoint(x,y) */
			if (valTop < 1) 
				return error("syntax error");

			opG = val[valTop-1];
			opD = val[valTop];

			if(opG.isBoolean() || opD.isBoolean())
			{
				return error("operand left or right mustn't be boolean");
			}

			val[valTop-1] = Type( Disjoint(opG.getInterval(),opD.getInterval()) );

			valTop--;
		break;

		case tEgale:
			/* apply E := x == y avec x et y boolean */
			if (valTop < 1) 
				return error("syntax error");

			opG = val[valTop-1];
			opD = val[valTop];

			if(opG.isInterval() || opD.isInterval())
			{
				return error("operand left or right mustn't be interval");
			}

			val[valTop-1] = Type( opG.getBoolean()==opD.getBoolean() );

			valTop--;
		break;


		case tEt:
			/* apply E := x Et y */
			if (valTop < 1) 
				return error("syntax error");

			opG = val[valTop-1];
			opD = val[valTop];

			if(opG.isInterval() || opD.isInterval())
			{
				return error("operand left or right mustn't be interval");
			}

			val[valTop-1] = Type( opG.getBoolean() && opD.getBoolean() );

			valTop--;
		break;


		case tOu:
			/* apply E := x Ou y */
			if (valTop < 1) 
				return error("syntax error");

			opG = val[valTop-1];
			opD = val[valTop];

			if(opG.isInterval() || opD.isInterval())
			{
				return error("operand left or right mustn't be interval");
			}

			val[valTop-1] = Type( Ou(opG.getBoolean() , opD.getBoolean()) );

			valTop--;
		break;


		case tRpr:
			/* pop () off stack */
			oprTop--;
		break;
	}
	oprTop--;
	return 0;
}



int ParserIntervalles::parse(void)
{
	/* initialize for next expression */
	oprTop = 0;
	valTop = -1;
	opr[oprTop] = tEof;
	firsttok = true;
	if (gettok())
		return 1;
	
	while(1)
	{
		/* input is value */
		if (tok == tVal)
		{
			/* shift token to value stack */
			if (shift())
				return 1;
			continue;
		}
	
		/* input is operator */
		printf("stk=%d tok=%d\n", opr[oprTop], tok);
		
		switch(parseTbl[opr[oprTop]][tok])
		{
			case R:
				if (reduce()) 
				{
					retour = false;
					return 1;
				}
			break;
			case S:
				if (shift()) 
				{
					retour = false;
					return 1;
				}
			break;
			case A:
				/* accept */
				if (valTop != 0)
				{
					retour = false;
					return error("syntax error");
				}
				return 0;
			case E1:
				retour = false;
				return error("missing right parenthesis");
			case E2:
				retour = false;
				return error("missing operator");
			case E3:
				retour = false;
				return error("unbalanced right parenthesis");
			case E4:
				retour = false;
				return error("invalid function argument");
			case E5:
				retour = false;
				return error("invalid type");
		}
	}
}


bool ParserIntervalles::eval(char *str,Type& res)
{
	eval(str);

    if(retour)
	{
		res = val[valTop];
	}

	return retour;
}

bool ParserIntervalles::eval(char *str)
{
	char strLeft[255];
	char strRigth[255];
	char* variable;
	int nbOfEgal;

	nbOfEgal = countOccurrence(str,"=");

	retour = true;

	switch(nbOfEgal)
	{
		case 0://pas d'affectation
			strcpy(chaine,str);
			parse();
			if(retour)
				cout<<"value="<<val[valTop]<<endl;
		break;

		case 1://une affectation
			splitExpression(str,strLeft,strRigth);
			variable = getVariableAffectation(strLeft);
			if(variable==NULL)
			{
				//erreur dans la dfinition de la variable
				error("syntaxe error: left operand must be a l-value");
				return false;
			}

			strcpy(chaine,strRigth);
			parse();

			if(retour==false)
			{
				//erreur dans l'expression de droite
				error("syntaxe error in right operand");
				return false;
			}

			doAffectation(variable,val[valTop]);
		break;

		default://impossible Erreur
			error("syntaxe error");
			return false;
	}
	
	
	
	return retour;
}

functionToken* ParserIntervalles::getNameFunction(int num)
{
	for(int i=0;tabFonctions[i].fname!=0;i++)
	{
		if(i==num)
			return &(tabFonctions[i]);
	}

	return NULL;
}

//sert  rcuprer la chaine comprise avant le prochain sparateur
int ParserIntervalles::getNextToken(char*chaine,char*token)
{
	unsigned int i,j,k;
	unsigned int size = strlen(chaine);
	char c;
	char* separateur;

	token[0]='\0';

	for(i=0,j=0;i<size;i++)
	{
		c = chaine[i];

		for(k=0;k<listeSeparateur.size();k++)
		{
			separateur = listeSeparateur.at(k);

			if(c==*separateur)
			{
				return i;
			}
		}

		token[j++] = c;
		token[j] = '\0';
	}
	
	return i;
}

void ParserIntervalles::Init()
{
	listeSeparateur.push_back(new char('+'));
	listeSeparateur.push_back(new char('-'));
	listeSeparateur.push_back(new char('*'));
	listeSeparateur.push_back(new char('/'));
	listeSeparateur.push_back(new char('('));
	listeSeparateur.push_back(new char(')'));
	listeSeparateur.push_back(new char(','));

	listeVariable.push_back(new variables("PI", Type(V_PI)) );

	listeVariable.push_back(new variables("true", Type((bool)true)) );
	listeVariable.push_back(new variables("false", Type((bool)false)) );
	listeVariable.push_back(new variables("TRUE", Type((bool)true)) );
	listeVariable.push_back(new variables("FALSE", Type((bool)false)) );
}

bool ParserIntervalles::isVariable(char *str)
{
	unsigned int i;

	for(i=0;str[i]!='\0';i++)
	{
		char c = str[i];

		if((c<'0' || c>'9') && c!='.')
			return true;
	}

	return false;
}

bool ParserIntervalles::getValeur(char *str,Type& val)
{
	unsigned int i;

	for(i=0;i<listeVariable.size();i++)
	{
		variables* var = listeVariable.at(i);

		if(var==NULL)
			return false;

		if(strcmp(var->name,str)==0)
		{
			val = var->getValue();
			return true;
		}
	}

	return false;
}

bool ParserIntervalles::setValeur(char *str,Type& val)
{
	unsigned int i;

	for(i=0;i<listeVariable.size();i++)
	{
		variables* var = listeVariable.at(i);

		if(var==NULL)
			return false;

		if(strcmp(var->name,str)==0)
		{
			var->setValue(val);
			return true;
		}
	}

	return false;
}



void ParserIntervalles::splitExpression(char *src, char *left, char *right)
{
	unsigned int indexSrc;
	unsigned int indexRight;
	bool find=false;

	memset(left,'\0',strlen(src)+1);
	memset(right,'\0',strlen(src)+1);

	for(indexSrc=0;indexSrc<strlen(src);indexSrc++)
	{
		if(src[indexSrc]=='=' && find==false)
		{
			find = true;
			indexRight = indexSrc+1;
			continue;
		}

		if(find)
		{
			right[indexSrc-indexRight]	= src[indexSrc];
		}
		else
		{
			left[indexSrc]				= src[indexSrc];
		}
	}
}

int ParserIntervalles::countOccurrence(const char *str, char *chaine)
{
	const char *newStr;

	newStr = strstr(str,chaine);

	if(newStr==NULL || strlen(newStr)<strlen(chaine))
		return 0;
	else
		return 1+countOccurrence(newStr+strlen(chaine),chaine);
}

char* ParserIntervalles::getVariableAffectation(char *str)
{
	int count=0;
	char *newStr;

	insertSpace(str);

	for(newStr = strtok(str, " ");newStr;newStr=strtok(NULL, " "))
	{
		count++;
	}

	if(count==1)
	{
		newStr = strtok(str, " ");
		
		for(int i=0;;i++)
		{
			functionToken* funToken = getNameFunction(i);
			
			if(funToken==NULL)
			{
				return newStr;
			}

			if(strcmp(newStr,funToken->fname)==0)
			{
				return NULL;
			}
		}

		//return NULL;
	}
	
	return NULL;
}

void ParserIntervalles::doAffectation(char *variable, Type val)
{
	unsigned int i;

	for(i=0;i<listeVariable.size();i++)
	{
		variables* var = listeVariable.at(i);

		if(var==NULL)
		{
			continue;
		}

		if(strcmp(var->name,variable)==0)
		{
			var->valeur = val;
			return;
		}
	}

	listeVariable.push_back(new variables(variable,val));
}







double fact(double n)
{
	double i, t;
	for (t = 1, i = 1; i <= n; i++)
		t *= i;
	return t;
}

double	Abs(const double& val)
{
	return (val>0)?val:-val;
}


double	Cos(const double& val)
{
	return cos(val);
}

double	Tan(const double& val)
{
	return tan(val);
}

double	Cotan(const double&val)
{
	return Tan(V_PI/2-val);
}

double	Exp(const double& val)
{
	return exp(val);
}

double	Log(const double& val)
{
	return log(val);
}

double	Max(const double&val1,const double&val2)
{
	return (val1>val2)?val1:val2;
}
double	Min(const double& val1,const double&val2)
{
	return (val1<val2)?val1:val2;
}

double	Power(const double& val,double indice)
{
	return pow(val,indice);
}

double	Sin(const double& val)
{
	return sin(val);
}

double	Sqr(const double& val)
{
	return val*val;
}

double	Sqrt(const double& val)
{
	return sqrt(val);
}

interval	Power(const interval& val,interval indice)
{
	return Power(val,(int)indice.GetInf());
}

interval	fact(interval n)
{
	return interval(fact(n.GetInf()));
}

iboolean	Non(const iboolean& x)
{
        if (x.value == itrue) return iboolean(ifalse);
	if (x.value == ifalse) return iboolean(itrue);
	return iboolean(iperhaps);
}

iboolean	Ou(const iboolean& x,const iboolean& y)
{
        if ( (x.value==itrue) || (y.value==itrue) ) return iboolean(itrue);
	if ( (x.value==iperhaps) || (y.value==iperhaps) ) return iboolean(iperhaps);
	return iboolean(ifalse);
}
