// Point3d.h: interface for the Point3d class.
//
//////////////////////////////////////////////////////////////////////

#ifndef _POINT3D
#define _POINT3D


#define Epsi 0.01

#include <math.h>
#include "Vecteur.h"

class Point3d  
{
public:
	static Vecteur toVecteur(Point3d pt1,Point3d pt2);
	Point3d();
	Point3d(const Point3d & pt);
	Point3d(float x, float y, float z);

	void normalize();
	void toFloat(float *tab);
	static float dist(Point3d pt1, Point3d pt2);

	float x;
	float y;
	float z;
	bool operator<(Point3d pt);
	bool operator==(Point3d pt);
	void operator+=(Point3d pt);
	Point3d operator+(Point3d pt);
	Point3d operator-(Point3d pt);
	void operator+=(Vecteur v);
	void operator*=(float coeff);
};

#endif
