#include "Probleme.h"
#define MAX 255

void Probleme::reload(void)
{
        if(this->ensContraintes.size())
        {
                load(loadFile);
        }
}


bool Probleme::load(const char* filename)
{
        Probleme* test=new Probleme;

        if(load(filename,test))
        {
                delete test;
                this->ensContraintes.clear();

                strcpy(loadFile,filename);

                this->parser.eval("O1 = I(0,0)");
                this->parser.eval("O2 = I(0,0)");
                this->parser.eval("O3 = I(0,0)");
                this->parser.eval("model = I(0,0)");

                Type val;

                parser.getValeur("O1",val);
                parser.getValeur("O2",val);
                parser.getValeur("O3",val);

                load(filename,this);
                return true;
        }

        if(test)
                delete test;

        return false;
}


bool Probleme::load(const char* filename,Probleme* pb)
{
        char buffer[255];
        char* token;

        if(pb==NULL)
                return false;

        Fichier fichier;

        FILE* errorFile=fopen("error.txt","w");

        if(errorFile==NULL)
                return false;

        if(!fichier.Init(filename))
	{
                fprintf(errorFile,"Fichier %s absent",filename);
                fclose(errorFile);
		return false;
	}

	if(!fichier.recherche("Mode="))
	{
                fprintf(errorFile,"champ \"Mode\" absent");
                fclose(errorFile);
                fichier.fermer();
                return false;
        }
        fichier.lire(buffer,'\n',MAX-1);

        token = strtok(buffer, " ");

        if(strcmp(token,"Inversion")==0)
        {
                pb->mode = INVERSION;
        }
        else
        if(strcmp(token,"Estimation")==0)
        {
                pb->mode = ESTIMATION;
        }
        else
        {
                fprintf(errorFile,"champ \"Mode\" = Inversion ou Estimation");
                fclose(errorFile);
                fichier.fermer();
                return false;
        }



        if(!fichier.recherche("DECLARATION\n"))
	{
                fprintf(errorFile,"champ \"DECLARATION\" absent");
                fclose(errorFile);
                fichier.fermer();
                return false;
        }

        if(!fichier.recherche("FDECLARATION\n"))
        {
                fprintf(errorFile,"champ \"FDECLARATION\" absent");
                fclose(errorFile);
                fichier.fermer();
                return false;
        }
        fichier.fermer();

        if(!fichier.Init(filename))
	{
                fprintf(errorFile,"Fichier %s absent",filename);
                fclose(errorFile);
		return false;
	}

        if(!fichier.recherche("DECLARATION\n"))
	{
                fprintf(errorFile,"champ \"DECLARATION\" absent");
                fclose(errorFile);
                fichier.fermer();
                return false;
        }

        bool finDeclaration=false;

        do
        {
                fichier.lire(buffer,'\n',MAX-1);

                if(strcmp(buffer,"FDECLARATION")==0)
                {
                        finDeclaration = true;
                }
                else
                {
                        if(pb->parser.eval(buffer)==false)
                        {
                                fprintf(errorFile,"syntaxe erreur dans %s",buffer);
                                fclose(errorFile);
                                fichier.fermer();
                                return false;
                        }
                }
        }while(finDeclaration==false);


        if(!fichier.recherche("MODELS\n"))
	{
                fprintf(errorFile,"champ \"MODELS\" absent");
                fclose(errorFile);
                fichier.fermer();
                return false;
        }

        if(!fichier.recherche("FMODELS\n"))
        {
                fprintf(errorFile,"champ \"FMODELS\" absent");
                fclose(errorFile);
                fichier.fermer();
                return false;
        }
        fichier.fermer();

        if(!fichier.Init(filename))
	{
                fprintf(errorFile,"Fichier %s absent",filename);
                fclose(errorFile);
		return false;
	}

        if(!fichier.recherche("MODELS\n"))
	{
                fprintf(errorFile,"champ \"MODELS\" absent");
                fclose(errorFile);
                fichier.fermer();
                return false;
        }

        bool finModels=false;

        do
        {
                fichier.lire(buffer,'\n',MAX-1);

                if(strcmp(buffer,"FMODELS")==0)
                {
                        finModels = true;
                }
                else
                {
                        MODEL* models = new MODEL;

                        if(models==NULL)
                        {
                                fprintf(errorFile,"syntaxe erreur dans model:%s",buffer);
                                fclose(errorFile);
                                fichier.fermer();
                                return false;
                        }

                        memset(models->model,'\0',255);

                        strcpy(models->model,buffer);

                        pb->ensModels.push_back(models);
                }
        }while(finModels==false);


        if(!fichier.recherche("CONTRAINTES\n"))
	{
                fprintf(errorFile,"champ \"CONTRAINTES\" absent");
                fclose(errorFile);
                fichier.fermer();
                return false;
        }

        if(!fichier.recherche("FCONTRAINTES\n"))
        {
                fprintf(errorFile,"champ \"FCONTRAINTES\" absent");
                fclose(errorFile);
                fichier.fermer();
                return false;
        }
        fichier.fermer();

        if(!fichier.Init(filename))
	{
                fprintf(errorFile,"Fichier %s absent",filename);
                fclose(errorFile);
		return false;
	}

        if(!fichier.recherche("CONTRAINTES\n"))
	{
                fprintf(errorFile,"champ \"CONTRAINTES\" absent");
                fclose(errorFile);
                fichier.fermer();
                return false;
        }

        bool finContraintes=false;
        do
        {
                fichier.lire(buffer,'\n',MAX-1);

                if(strcmp(buffer,"FCONTRAINTES")==0)
                {
                        finContraintes = true;
                }
                else
                {
                        Contraintes* contraintes = new Contraintes;

                        if(contraintes==NULL)
                        {
                                fprintf(errorFile,"syntaxe erreur dans contrainte:%s",buffer);
                                fclose(errorFile);
                                fichier.fermer();
                                return false;
                        }

                        memset(contraintes->expression,'\0',255);

                        strcpy(contraintes->expression,buffer);

                        pb->ensContraintes.push_back(contraintes);
                }
        }while(finContraintes==false);

        if(pb->ensContraintes.size()==0)
        {
                fprintf(errorFile,"Erreur, fichier doit contenir des contraintes\n");
                fclose(errorFile);
                fichier.fermer();
                return false;
        }

        fichier.fermer();

        return true;
}


bool    Probleme::evalContrainte(Contraintes*contrainte, iboolean &res)
{
        if(contrainte==NULL)
                return false;

        Type resultat;
        if(!parser.eval(contrainte->expression,resultat))
                return false;

        res = resultat.getBoolean();

        return true;
}

bool    Probleme::evalContraintes(iboolean & res)
{
        unsigned int i;

        res = true;

        for(i=0;i<this->ensContraintes.size();i++)
        {
                iboolean resTmp;
                if( evalContrainte(ensContraintes.at(i),resTmp))
                {
                        res = res && resTmp;
                }
                else
                {
                        return false;
                }
        }

        return true;
}
bool    Probleme::evalModel(void)
{
        /*
        if(!parser.eval(model,res))
                return false;
        return true;
        */

        for(unsigned int i=0;i<this->ensModels.size();i++)
        {
                MODEL* model = ensModels.at(i);

                if(model==NULL)
                        return NULL;

                if(!parser.eval(model->model))
                        return false;
        }

        return true;
}
