// Type.h: interface for the Type class.
//
//////////////////////////////////////////////////////////////////////

#ifndef TYPE_H
#define TYPE_H
#include "interval.h"
#include "iboolean.h"

typedef enum
{
	INTERVAL,
	_BOOLEAN
}typage;

class Type  
{
	interval inter;
	iboolean boolean;
public:
	Type(bool val);
	typage type;
	Type(float val);
	Type(int val);
	Type(double val);
	Type(Type const &t);
	Type(iboolean _bool);
	Type(interval _inter);
	iboolean getBoolean(void)const;
	interval getInterval(void)const;
	bool isInterval(void);
	bool isBoolean(void);
	Type();
	virtual ~Type();

	friend ostream& operator<<(ostream& ,const Type&);

};

#endif
