//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit2.h"
#include "sivia.h"
#pragma package(smart_init)

//initialisation des variables statiques
int CalculPave::nbPave = 0;
double CalculPave::precision = 0.05;
bool CalculPave::fin = true;


__fastcall CalculPave::CalculPave(bool CreateSuspended,TYPE_RESOLUTION type)
        : TThread(CreateSuspended)
{
        CalculPave::nbPave = 0;
        typeCalculPave = type;
}
//---------------------------------------------------------------------------
void __fastcall CalculPave::Execute()
{
        CalculPave::fin = false;

        ListePaveBleu.clear();
        ListePaveRouge.clear();
        ListePaveVert.clear();

        GO(&nbPave,&precision,typeCalculPave);

        CalculPave::fin = true;
}

bool __fastcall CalculPave::IsStopped()
{
        return Terminated;
}

void __fastcall CalculPave::save(const char*file)
{
        FILE* fichier = fopen(file,"w");
        unsigned int i;
        pave3d* pave;

        fprintf(fichier,"Resum:\n");

        fprintf(fichier,"nombre pave rouge: [%d]\n",ListePaveRouge.size());
        fprintf(fichier,"nombre pave vert: [%d]\n",ListePaveVert.size());
        fprintf(fichier,"nombre pave bleu: [%d]\n",ListePaveBleu.size());
        fprintf(fichier,"--------------------------------------------\n");

        fprintf(fichier,"Total: [%d]\n",ListePaveBleu.size()+ListePaveRouge.size()+ListePaveVert.size());


        fprintf(fichier,"\nPave rouge:\n");
        for(i=0;i<ListePaveRouge.size();i++)
        {
                pave = ListePaveRouge.at(i);
                fprintf(fichier,"O1=I(%f,%f) # O2=I(%f,%f) # O3=I(%f,%f)\n",
                        pave->X.GetInf(),
                        pave->X.GetSup(),
                        pave->Y.GetInf(),
                        pave->Y.GetSup(),
                        pave->Z.GetInf(),
                        pave->Z.GetSup());
        }

        fprintf(fichier,"\nPave vert:\n");
        for(i=0;i<ListePaveVert.size();i++)
        {
                pave = ListePaveVert.at(i);
                fprintf(fichier,"O1=I(%f,%f) # O2=I(%f,%f) # O3=I(%f,%f)\n",
                        pave->X.GetInf(),
                        pave->X.GetSup(),
                        pave->Y.GetInf(),
                        pave->Y.GetSup(),
                        pave->Z.GetInf(),
                        pave->Z.GetSup());
        }

        fprintf(fichier,"\nPave bleu:\n");
        for(i=0;i<ListePaveBleu.size();i++)
        {
                pave = ListePaveBleu.at(i);
                fprintf(fichier,"O1=I(%f,%f) # O2=I(%f,%f) # O3=I(%f,%f)\n",
                        pave->X.GetInf(),
                        pave->X.GetSup(),
                        pave->Y.GetInf(),
                        pave->Y.GetSup(),
                        pave->Z.GetInf(),
                        pave->Z.GetSup());
        }

        fclose(fichier);

}
//---------------------------------------------------------------------------
