// amera.h: interface for the Camera class.
//
//////////////////////////////////////////////////////////////////////

#ifndef _CAMERA
#define _CAMERA

#include "Vecteur.h"
#include "Matrice.h"
#include "Point3d.h"
#include <math.h>

#define PI 3.14159265358979323846264

typedef enum
{
	GAUCHE=0,
	DROITE,
	HAUT,
	BAS
}MVT_CAM;


/**
*	Classe permettant de grer une camera
*
*/
class Camera
{
public:
	bool translation(MVT_CAM mvt,float vitesse);
	static double pisur180;

	void toScreen();
	virtual void rotateyz(float agl);
	virtual void rotatexz(float agl);
	virtual void avance(float vitesse);
	virtual void update_camera();
	virtual void modele_inverse(Point3d pt);
	Camera(const Camera & cam);
	
	Point3d pos;// position de la source de la camera
	Point3d targ;// position de la cible de la camera
	
	double aglxz;
	double aglyz;

        float pas;

	Vecteur dir;// vecteur pointant dans la direction o "regarde" le camera

	bool operator<(Camera cam);
	bool operator==(Camera cam);

	Camera();
	virtual ~Camera();

};

typedef Camera * lpCamera;

#endif
