// ameraPolaire.cpp: implementation of the CameraPolaire class.
//
//////////////////////////////////////////////////////////////////////

#include "ameraPolaire.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CameraPolaire::CameraPolaire()
{
	distSrcDest = 5.0;
}

CameraPolaire::~CameraPolaire()
{

}


void CameraPolaire::rotatexz(float agl)
{
	if(agl!=0)
	{
		aglxz+=agl;
		if(aglxz>360)
			aglxz-=360;
		if(aglxz<0)
			aglxz=360+aglxz;

		update_camera();
	}
}

void CameraPolaire::rotateyz(float agl)
{
	if( agl!=0 && aglyz+agl>-90 && aglyz+agl<90)
	{
		aglyz+=agl;
		update_camera();
	}
}

void CameraPolaire::modele_inverse(Point3d pt)
{
	double sinB;
	double B;
	double A;

	pt.normalize();

	A = asin(pt.y);
	sinB = pt.z/(cos(A));

	B = asin(sinB);

	aglyz = A / pisur180;
	aglxz = B / pisur180;

	distSrcDest = Point3d::dist(pos,targ);
}


void CameraPolaire::avance(float vitesse)
{
	Vecteur v;

	v = this->dir;

	v*=-vitesse;

	this->pos	+= v;

	distSrcDest = Point3d::dist(pos,targ);
}

void CameraPolaire::update_camera()
{
	double tmp1;
	double tmp2;
	double tmp3;
	double tmp4;

	double ag1 = (double)(aglyz*pisur180);
	double ag2 = (double)(aglxz*pisur180);


	tmp1 = cos(ag1);
	tmp2 = sin(ag1);
	
	tmp3 = cos(ag2);
	tmp4 = sin(ag2);

	

	dir.dx=tmp1 * tmp3;
	dir.dz=tmp1 * tmp4;
	dir.dy=tmp2;

	pos.x = (float)(targ.x + distSrcDest *dir.dx);
	pos.y = (float)(targ.y + distSrcDest *dir.dy);
	pos.z = (float)(targ.z + distSrcDest *dir.dz);
}

CameraPolaire::CameraPolaire(const CameraPolaire &cam)
{
	distSrcDest = cam.distSrcDest;
}
