// fichier.cpp: implementation of the fichier class.
//
//////////////////////////////////////////////////////////////////////
#include "fichier.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

Fichier::Fichier()
{
   id_fichier=NULL;
}

Fichier::Fichier(const char * chaine)
// version de constructeur avec initialisation
// direct de "id_fichier" seulement s'il exsite
{		
	id_fichier=fopen(chaine,"r+");
}

Fichier::~Fichier()
{

}

BOOL Fichier::Init(const char * chaine)
// sert  faire pointer l'objet fichier sur
// le fichier "chaine" seulement s'il existe
{
	if(strlen(chaine)<=3)
		return false;
	id_fichier=fopen(chaine,"r");
	if(id_fichier==NULL)
		return false;
	fclose(id_fichier);
	id_fichier=fopen(chaine,"r+");
	return true;
}


BOOL Fichier::test_id_fichier()
// sert  savoir si l'objet pointe actuellement
// sur un fichier
{
	if(id_fichier==NULL)
		return false;
	else
		return true;
}

BOOL Fichier::recherche(const char * chaine)
// sert  rechercher la chaine "chaine" dans le fichier
// point par l'objet
// Remarque: 1) la recherche commence  partir de la position
//				de id_fichier dans le fichier.
//		     2) si la recherche aboutie, id_fichier pointe juste
//				aprs la chaine recherche
{
	char ch='g';
	int ok=0;
	int i;

	while(!ok && ch!=EOF)
	{
		do
		{
			ch=fgetc(id_fichier);
		}while(ch!=*chaine && ch!=EOF);
		ok=1;
		if(ch!=EOF)
		{
			for(i=1;*(chaine+i)!='\0';i++)
			{
				ch=fgetc(id_fichier);
				if(ch!=*(chaine+i))
				{
				   ok=0;
				   break;
				}				
			}			
			if(ok==0)
			{
				ungetc(ch,id_fichier);
				for(i-=1;i>1;i--)
					ungetc(*(chaine+i),id_fichier);
			}
		}
	}
	if(ch!=EOF)
		return true;
	else
		return false;
}

BOOL Fichier::lire(char * dest, char fin , int max)
// copie tous les octets du fichier compris entre la position
// courante de id_fichier dans le fichier et le caractre "fin"
// Remarque: l'opration s'arrte galement lorsque la fonction
//			 recontre le caractre de fin de fichier ou
//			 que l'on a dpass le nombre d'octet max ("max")
{		
	int i=0;
	char ch;
	
	memset(dest,'\0',max);
	
	ch=fgetc(id_fichier);
	
	while(ch!=fin && ch!=EOF)
	{
		if(i>=max)
			return false;

		if(ch!=EOF)
			dest[i++]=ch;

		ch=fgetc(id_fichier);
	}
	
	if(ch!=EOF)
		return true;
	else
		return false;
}

BOOL Fichier::fermer()
// sert  librer un fichier
{
	if(fclose(id_fichier)==EOF)
		return false;

	id_fichier=NULL;
	return true;
}

void Fichier::Set_eof()
// sert  positionner id_fichier  la fin du fichier
{
	fseek( id_fichier , 0L , SEEK_END );
}

void Fichier::Set_sof()
// sert  positionner id_fichier au dbut du fichier
{
	fseek( id_fichier , 0L , SEEK_SET );
}

long Fichier::Getposition()
// renvoie la position de id_fichier dans le fichier
// position cod en nombre d'octet
{
	return ftell(id_fichier);
}
  
BOOL Fichier::Setpos(long pos)
// sert  positionner id_fichier dans le fichier
{
	if(fseek( id_fichier , pos , SEEK_SET ))
		return false;
	return true;
}

void Fichier::Create_file(const char * name)
// sert  crer un fichier
// attention : 1) si le fichier existe, il est dtruit
//             2) l'objet fichier ne pointe pas dessus
{
	FILE *stream;
	stream=fopen(name,"w");
	if(stream!=NULL)
		fclose(stream);
}

BOOL Fichier::ecrire(const char * chaine)
// sert  crire dans le fichier la chane "chaine"
{
	Set_eof();
	fprintf(id_fichier,"%s",chaine);
	return true;
}

int Fichier::Nbr_de_fichier(char * chaine)
// retourne le nombre de fichier correspondant  la recherche "chane"
// qui se trouvent dans le rpertoire courant;
// fonctionne comme la fonction dir sauf qu'elle retourne le nombre de rsultat
{
	int nbr;
	long handle;
	struct _finddata_t ffblk;
	
	if( (handle=_findfirst(chaine,&ffblk)) == -1L )
		nbr=0;
	else
	{
		nbr=1;
		while(_findnext(handle,&ffblk)==0)
			nbr++;
		_findclose(handle);
	}
	return nbr;
}

void Fichier::getFile(char *chaine, int nb, char *sortie)
{
	int nbr;
	long handle;
	struct _finddata_t ffblk;

	nbr=0;
	
	if( (handle=_findfirst(chaine,&ffblk)) == -1L )
		nbr=0;
	else
	{
		do
		{
			if(nbr == nb)
			{
				strcpy(sortie,ffblk.name);
				break;
			}
			nbr++;
		}while(_findnext(handle,&ffblk)==0);

		_findclose(handle);
	}
}

int Fichier::getFilePos(char *chaine,char *path,char *sortie)
{
	int nbr;
	long handle;
	struct _finddata_t ffblk;
	char tmp[400];

	nbr=0;
	
	if( (handle=_findfirst(chaine,&ffblk)) == -1L )
		nbr=0;
	else
	{
		do
		{
			sprintf(tmp,"%s%s",path,ffblk.name);
			if(strcmp(sortie,tmp)==0)
			{
				return nbr;
				break;
			}
			nbr++;
		}while(_findnext(handle,&ffblk)==0);

		_findclose(handle);
	}

	return -1;
}