#ifndef __INTERVAL__
#define __INTERVAL__

#include <iostream.h>
#include "iboolean.h"
#define oo 1.E60    //definition de l'infini not oo

double Arccossin(const double&,const double&);
double Arg      (const double&,const double&);

class interval
{
public:
    double inf;
private:
    double sup;   //sup NE SOIT PAS ACCESSIBLE SI
                // IsInterval = FALSE
public:
    bool isInterval;    // VRAI : interval, FAUX : reel
    bool isEmpty;

public:
    interval ();
    interval (double);    // Pas const pour conversion double -> interval
    interval (const double&, const double&);
    interval (const interval&);
    // OPERATEURS
    friend interval operator+ (const interval&,const interval&);
    friend interval operator- (const interval&);
    friend interval operator- (const interval&, const interval&);
    friend interval operator* (const interval&, const interval&);
    friend interval operator/ (const interval& ,const interval&);
    //friend interval operator& (interval&,interval&);//intersection
    friend ostream& operator<<(ostream& ,const interval&);
    // FONCTION MEMBRES
    double GetInf (void) const;
    double GetSup (void) const;
    void SetInf (double);
    void SetSup (double);
    // FONCTION AMIES
    friend interval  Abs        (const interval&);
    friend double    Center     (const interval&);
    friend interval  Cos        (const interval&);
    friend interval  Cotan      (const interval&);
    friend bool      Disjoint   (const interval&,const interval&);
    friend void      Egal       (interval &y, interval& x);
    friend double    Eloignement(const interval&,const interval&);
    friend interval  Exp        (const interval&);
    friend bool      In         (double,const interval&);
    friend iboolean  In         (const interval&,const interval&);
    friend double    Inf        (const interval&);
    friend interval  Inflate    (const interval&,double);
    friend interval  Inter      (const interval&,const interval&);
    friend void      Inter1     (interval&, interval&,const interval&,const interval&, const interval&);
    friend interval  Log        (const interval&);
    friend interval  Max        (const interval&,const interval&);
    friend interval  Min        (const interval&,const interval&);
    friend void      Min        (interval&,interval&,interval&);
    friend void      Min        (interval&,interval&,interval&,interval&);
    friend bool      OverLap    (const interval&,const interval&);
    friend interval  Parabole   (const interval& x,double a,double b,double c);
    friend double    Pioche     (const interval&);
    friend void      Plus       (interval &z, interval& x, interval& y);
    friend interval  Power      (const interval&,int);
    friend interval  Sech       (const interval&);
    friend interval  Sin        (const interval&);
    friend interval  Sqr        (const interval&);
    friend interval  Sqrt       (const interval&);
    friend interval  SqrtPos    (const interval&);
    friend bool      Subset     (const interval&,const interval&);
    friend bool      Subset     (const interval&,const interval&,double);
    friend void      Sucre      (interval&, const interval&);
    friend double    Sup        (const interval&);
    friend interval  Tan        (const interval&);
    friend double    ToReel      (const interval&);
    friend interval  Union      (const interval&, const interval&);
    friend double    Width      (const interval&);
};

#endif
