//---------------------------------------------------------------------------
#ifndef repereH
#define repereH
#include "box.h"
#include <stdio.h>
#include <string.h>

#define XFIG_HEADER   "#FIG 3.2\nLandscape\nCenter\nInches\nLetter\n100.0\nSingle\n-2\n1200 2\n"
#define XFIG_BOX_HEADER  "2 2 0 %d 0 %d 50 0 20 0.000 0 0 -1 0 0 5\n"
#define XFIG_LINE_HEADER "2 %d 0 %d %d 0 50 0 -1 0.000 0 0 -1 0 0 %d\n"
#define XFIG_CONTOUR_HEADER  "2 2 0 1 %d 6 50 0 -1 0.000 0 0 -1 0 0 5\n"


#define XFIG_BLUE     1
#define XFIG_RED      4
#define XFIG_YELLOW   6
#define XFIG_WHITE   6

#define GRID          1  // 1 si le quadrillage est visible, 0 sinon

#define XFIG_COOR_XMIN     50
#define XFIG_COOR_XMAX  10000
#define XFIG_COOR_YMIN     50
#define XFIG_COOR_YMAX   8700

#define XMIN_DEF  -1.0
#define XMAX_DEF   1.0
#define YMIN_DEF  -1.0
#define YMAX_DEF   1.0

//---------------------------------------------------------------------------
class repere
{
 private:
  FILE *f;
  interval      xfig_x;
  interval      xfig_y;
  char          nom_fic[256];
  double        coeff_x_a;
  double        coeff_x_b;
  double        coeff_y_a;
  double        coeff_y_b;
  int           nb_division;

  void CreateFicXfig();
  void InitCoeff_x_y();

 public:
  interval	interval_y;
  interval	interval_x;

  repere (const char *);
  repere();
  repere (const char *, double,double,double,double);
  void DrawBox (box&,int,int,int);
  void DrawContour (box&,int);
  void ResetDivision();
  void IncDivision();
  int GetNbdivision();
  void DrawLine(interval *,int);
  void DrawBaton(interval *,int);

};

#endif
