//---------------------------------------------------------------------------
#include <vcl.h>
#include <list.h>
#include <vector>
#pragma hdrstop

#include "sivia.h"
#include "repere_xfig.h"
#include "box.h"
#include "Unit2.h"


#include "Echantillon.h"
#include "Probleme.h"
#include "Type.h"

extern Echantillons _echantillon;
extern Probleme probleme;

iboolean Inside(box& P);
void resolContraction(box& P);
//---------------------------------------------------------------------------
#pragma package(smart_init)
//----------------------------------------------------------------------

int* nbPave;
double *precision;

extern CalculPave *CalculPaveThread;

void ajoutPaveVert(box P)
{
        //ajout du pave dans la liste des paves vert
        CalculPaveThread->ListePaveVert.push_back(new pave3d(P,0,1,0));
        *nbPave = *nbPave + 1;
        Form1->updateText();
}


void ajoutPaveRouge(box P)
{
        //ajout du pave dans la liste des paves rouge
        CalculPaveThread->ListePaveRouge.push_back(new pave3d(P,1,0,0));
        *nbPave = *nbPave + 1;
        Form1->updateText();
}


void ajoutPaveBleu(box P)
{
        //ajout du pave dans la liste des paves bleu
        CalculPaveThread->ListePaveBleu.push_back(new pave3d(P,0,0,1));
        *nbPave = *nbPave + 1;
        Form1->updateText();
}

//----------------------------------------------------------------------

void SIVIApile(box& P)
{
    box P1(2,true);
    box P2(2,true);

    if(CalculPaveThread && CalculPaveThread->IsStopped())
        return;

    if (Width(P)<*precision)
    {
        ajoutPaveVert(P);
        return;
    }

    iboolean test=Inside(P);

    if (test==itrue)
    {
        ajoutPaveRouge(P);
    }
    else
    {
        if (test!=ifalse)
         {
                Bisect(P,P1,P2);
                SIVIApile(P1);
                SIVIApile(P2);
         }
        if(test==ifalse)
        {
                ajoutPaveBleu(P);
        }
    }
} ;

void SIVIAfile(box P)
{
    box P1(2,true);
    box P2(2,true);
    list<box> L;
    L.push_back(P);
    while (!L.empty())
    {
        if(CalculPaveThread && CalculPaveThread->IsStopped())
                return;

        P=L.front();
        L.pop_front();
        iboolean test=Inside(P);
        if (Width(P)<*precision)
        {
                ajoutPaveVert(P);
        }
        else
        {
                if (test==itrue)
                         ajoutPaveRouge(P);
                else
                {
                        if (test!=ifalse)
                        {
                                Bisect(P,P1,P2);
                                L.push_back(P1);
                                L.push_back(P2);
                        }
                       if (test==ifalse)
                        {
                                ajoutPaveBleu(P);
                        }
                }
        }
    }
} ;
//----------------------------------------------------------------------


//sert  initialiser les donnes du problme
box* __fastcall Initialisation()
{
    box* P0 = new box(3,true);
    Type P[3];

    //rcupere les valeurs des paramtres
    probleme.parser.getValeur("O1",P[0]);
    probleme.parser.getValeur("O2",P[1]);
    probleme.parser.getValeur("O3",P[2]);

    (*P0)[1] = P[0].getInterval();
    (*P0)[2] = P[1].getInterval();
    (*P0)[3] = P[2].getInterval();

    if(probleme.mode==ESTIMATION)
    //on initialise les variables X1..Xn
    {
        unsigned int num;
        bool res;
        num = _echantillon.getNumVariable();
        char temp[255];

        for(unsigned int i=0;i<num;i++)
        {
                memset(temp,'\0',255);
                sprintf(temp,"X%d = I(0,0)",i+1);
                res = probleme.parser.eval(temp);

                res = res && true;//juste pour debugger (mettre un point d'arret)
        }
    }

    if(CalculPaveThread)
        CalculPaveThread->boxInit = *P0;

    return P0;
}

void autreAlgo(box& P)
{
    box P1(2,true);
    box P2(2,true);

    list<box> L;
    L.push_back(P);

    while (!L.empty())
    {
        if(CalculPaveThread && CalculPaveThread->IsStopped())
                return;

        P=L.front();
        L.pop_front();

        resolContraction(P);

        iboolean test=Inside(P);
        double taille = Width(P);

        taille = (taille<0)?-taille:taille;
        if(taille<*precision)
        {
                ajoutPaveVert(P);
        }
        else
        {
                if (test==itrue)
                         ajoutPaveRouge(P);
                else
                {
                        if (test!=ifalse)
                        {
                                Bisect(P,P1,P2);
                                L.push_back(P1);
                                L.push_back(P2);
                        }
                        if (test==ifalse)
                        {
                                ajoutPaveBleu(P);
                        }
                }
        }
    }
}


void resolContraction(box& P)
{
        box P1[2];
        double taille[2];
        int index = 0;

        #define MAX_K 1000
        interval z1[MAX_K],z2[MAX_K],z3[MAX_K],z4[MAX_K];


        for(int i=0;i<MAX_K;i++)
        {
        z1[i] = interval(-100,100);
        z2[i] = interval(-100,100);
        z3[i] = interval(-100,100);
        z4[i] = interval(-100,100);
        }

        //for(int i=0;i<100;i++)
        while(1)
        {
                for(unsigned int ech=0;ech<_echantillon.nbEchantillons;ech++)
                {
                //on spcifie l'chantillon
                _echantillon.setNumEchantillon(ech);

                //on ecrie le modle
                //y = o1 exp(-o2 * X)

                z1[ech] = -P[2]*_echantillon.X(1);
                z2[ech] = Exp(z1[ech]);
                z3[ech] = z2[ech]*P[1];
                z4[ech] = Inter(z3[ech],_echantillon.X(2));
                }

                for(unsigned int ech=0;ech<_echantillon.nbEchantillons;ech++)
                {
                //on spcifie l'chantillon
                _echantillon.setNumEchantillon(ech);

                z3[ech] = Inter(z4[ech],z3[ech]);
                z2[ech] = Inter(z3[ech]/P[1],z2[ech]);
                P[1] = Inter(z3[ech]/z2[ech],P[1]);
                z1[ech] = Inter(Log(z2[ech]),z1[ech]);
                P[2] = Inter(-z1[ech]/_echantillon.X(1),P[2]);
                }

                if(index==0)
                {
                        P1[0] = P;
                        index = 1;
                        taille[0] = Width(P1[0]);
                }
                else
                {
                        P1[1] = P;
                        index = 0;
                        taille[1] = Width(P1[1]);
                        if(taille[0] == taille[1])
                        {
                                break;
                        }
                }
//                ajoutPaveBleu(P);
        }
}

//fonction permettant de dcider si un pave est compris
//dans l'ensemble des solutions
iboolean Inside(box& P)
{
    iboolean dedans;
    interval model;

    //rentre dans le systeme, les valeurs des parametres theta n
    probleme.parser.setValeur("O1",Type(P[1]));
    probleme.parser.setValeur("O2",Type(P[2]));
    probleme.parser.setValeur("O3",Type(P[3]));

    switch(probleme.mode)
    {
        case INVERSION:
                if(!probleme.evalModel())
                {
                        //erreur dans l'analyse de l'expression de model
                        model = interval(0,0);
                }

                if(!probleme.evalContraintes(dedans))
                {
                        //erreur dans l'analyse des contraintes
                        dedans = false;
                }
                return dedans;
                
        case ESTIMATION:
                dedans = true;
                for(unsigned int ech=0;ech<_echantillon.nbEchantillons;ech++)
                {
                        iboolean dedansBis;
                        //on spcifie l'chantillon
                        _echantillon.setNumEchantillon(ech);

                        for(unsigned int i=0;i<_echantillon.getNumVariable();i++)
                        {
                                char X[255];
                                memset(X,'\0',255);
                                sprintf(X,"X%d",i+1);

                                interval X_coupure = _echantillon.X(i+1);
                                float centre = (X_coupure.GetSup()+X_coupure.GetInf())/2;
                                float coupe = 0;
                                float bruitBlanc = 0.00001;

                                switch(Form1->coupure.type)
                                {
                                        case C_TRAPEZE:
                                        case C_TRIANGLE:
                                            coupe = ( Form1->coupure.alpha*(Form1->coupure.l-2)+2 ) / 2;
                                            X_coupure = interval(centre-coupe-bruitBlanc,centre+coupe+bruitBlanc);
                                        break;
                                }


                                probleme.parser.setValeur(X,Type(X_coupure));
                        }

                        if(!probleme.evalModel())
                        {
                                //erreur dans l'analyse de l'expression de model
                                model = interval(0,0);
                        }

                        if(!probleme.evalContraintes(dedansBis))
                        {
                                //erreur dans l'analyse des contraintes
                                dedansBis = false;
                        }

                        dedans = dedans && dedansBis;
                }
                return dedans;
        default:
                return false;
    }

    //return false;
};


void __fastcall GO(int *_nbPave,double* _precision,TYPE_RESOLUTION i)
{
    nbPave = _nbPave;
    precision = _precision;

    box* P = Initialisation();

    /*
    autreAlgo(*P);

    return;
    */

    switch(i)
    {
        case M_PILE:
                SIVIApile(*P);
        break;
        case M_FILE:
                SIVIAfile(*P);
        break;
        case M_AUTO:
        {
                //int nbFois = 0;
                char temp[255];
                do
                {
                        CalculPaveThread->ListePaveBleu.clear();
                        CalculPaveThread->ListePaveRouge.clear();
                        CalculPaveThread->ListePaveVert.clear();
                        SIVIAfile(*P);

                        if(CalculPaveThread->ListePaveRouge.size()==0)
                        {
                                *precision = *precision*.1;
                                sprintf(temp,"%f",*precision);
                                Form1->precision->Text = temp;

                                if(*precision<0.000005)
                                {
                                        break;
                                        /*
                                        *precision = 0.5;
                                        sprintf(temp,"%f",*precision);
                                        Form1->precision->Text = temp;
                                        // on est dans le cas
                                        //w( [f]([xi]) ) > w( [yi] )
                                        if(_echantillon.nbEchantillons>0)
                                        {
                                                //on ajoute du bruit
                                                _echantillon.addBruitBlanc(0.01);
                                        }
                                        */
                                }
                        }
                        else
                        {
                                break;
                        }
                }while(1);
        }
        break;
    }

    delete P;
    probleme.reload();
} ;
//----------------------------------------------------------------------

